#include <stdlib.h>
#include <string.h>
#include "matrix.h"

// TODO Matrix-Funktionen implementieren

MatrixType createMatrix(unsigned int rows, unsigned int cols)
{
    MatrixType m;
    m.rows = rows;
    m.cols = cols;
    m.values = (MatrixType *)malloc(rows * cols * sizeof(MatrixType));
    if (m.values == NULL) {
        m.rows = 0;
        m.cols = 0;
        return m;
    }
    for (unsigned int i = 0; i < rows * cols; ++i) {
        m.values[i] = 0.0; // Standardwert
    }
    return m;
}

void clearMatrix(Matrix *matrix)
{
    if (matrix->values != NULL) {
        free(matrix->values);
    }
    matrix->values = NULL;
    matrix->rows = 0;
    matrix->cols = 0;
}

void setMatrixAt(MatrixType value, Matrix matrix, unsigned int rowIdx, unsigned int colIdx)
{
    if (rowIdx < matrix.rows && colIdx < matrix.cols) {
        matrix.values[rowIdx * matrix.cols + colIdx] = value;
    }
}

MatrixType getMatrixAt(const Matrix matrix, unsigned int rowIdx, unsigned int colIdx)
{
    if (rowIdx < matrix.rows && colIdx < matrix.cols) {
        return matrix.values[rowIdx * matrix.cols + colIdx];
    }
    return 0.0; // Fallback-Wert
}

Matrix add(const Matrix matrix1, const Matrix matrix2)
{
    Matrix result = createMatrix(0, 0);
    if (matrix1.rows != matrix2.rows || matrix1.cols != matrix2.cols) {
        return result;
    }

    result = createMatrix(matrix1.rows, matrix1.cols);
    for (unsigned int i = 0; i < matrix1.rows; ++i) {
        for (unsigned int j = 0; j < matrix1.cols; ++j) {
            MatrixType sum = getMatrixAt(matrix1, i, j) + getMatrixAt(matrix2, i, j);
            setMatrixAt(sum, result, i, j);
        }
    }
    return result;
}

Matrix multiply(const Matrix matrix1, const Matrix matrix2)
{
    Matrix result = createMatrix(0, 0);
    if (matrix1.cols != matrix2.rows) {
        return result;
    }

    result = createMatrix(matrix1.rows, matrix2.cols);
    for (unsigned int i = 0; i < matrix1.rows; ++i) {
        for (unsigned int j = 0; j < matrix2.cols; ++j) {
            MatrixType sum = 0.0;
            for (unsigned int k = 0; k < matrix1.cols; ++k) {
                sum += getMatrixAt(matrix1, i, k) * getMatrixAt(matrix2, k, j);
            }
            setMatrixAt(sum, result, i, j);
        }
    }
    return result;